package com.tzld.piaoquan.ad.engine.service.predict.container;

import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.ad.engine.commons.feign.CommonResponse;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.LongVideoFeign;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.request.AbTestConfigRequest;
import com.tzld.piaoquan.ad.engine.commons.math.Tuple;
import com.tzld.piaoquan.ad.engine.service.predict.impl.PredictModelServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

@Component
public class AbTestConfigContainer {
    private final static Logger log = LoggerFactory.getLogger(PredictModelServiceImpl.class);
    @Autowired
    LongVideoFeign longVideoFeign;
    @Value("${ad.abtest.time.plan.code:555}")
    String adTestCode;

    //List<Tuple<Integer>>
    Map<String,List<JSONObject>> adTimePlanMap=new HashMap<>();
//    Map<Integer,Map<String,List<JSONObject>>> appAdTimePlanMap=new ConcurrentHashMap<>() ;
//    @PostConstruct
//    public void initContainer(){
//        Timer timer = new Timer();
//        timer.schedule(new TimerTask() {
//            @Override
//            public void run() {
//                try {
////                    for (Integer appType:appAdTimePlanMap.keySet()){
////                        initMap(appType,"ab_test002");
////                    }
//                    initMap(3,"ab_test002");
////                    log.info("svc=refresh_adTimePlanMap appAdTimePlanMap={}",JSONObject.toJSONString(appAdTimePlanMap));
//                    log.info("svc=refresh_adTimePlanMap adTimePlanMap={}",JSONObject.toJSONString(adTimePlanMap));
//                }catch (Exception e){
//                    e.printStackTrace();
//                }
//            }
//        }, 0, 1000*30);
//    }

//    public void initMap(Integer appType,String typeValue){
//        AbTestConfigRequest request=new  AbTestConfigRequest();
//        if(appType==null){
//            request.setAppType(0);
//        }else{
//            request.setAppType(appType);
//        }
//        request.setTypeValue(typeValue);
//        CommonResponse<JSONObject> response=longVideoFeign.getAbTestConfig(request);
//        log.info("svc=initAdTimePlanMap_getConfigFromLongVideoApi response={}",JSONObject.toJSONString(response));
//        JSONObject object=response.getData();
//        for(Map.Entry<String,Object> entry:object.getInnerMap().entrySet()){
//            for(Map<String,Object> map:(List<Map>)entry.getValue()){
//                if(adTestCode.equals(map.get("abExpCode").toString())){
//                    adTimePlanMap=JSONObject.parseObject(map.get("configValue").toString(),Map.class);
//                    break;
//                }
//            }
//        }
//    }

//    public Boolean containsCode(String code){
//        return adTimePlanMap.keySet().contains(code);
//    }

    public Boolean containsCode(Map<String,List<JSONObject>> configMap,String code){
        return configMap.keySet().contains(code);
    }

//    public Boolean inWithoutAdTime(String code,Integer hourOfDay){
//        Boolean flag=false;
//        for(JSONObject object:adTimePlanMap.getOrDefault(code,new ArrayList<>())){
//            if(object.getInteger("x")<=hourOfDay&&hourOfDay<object.getInteger("y")){
//                return true;
//            }
//        }
//        return flag;
//    }

    public Boolean inWithoutAdTime(Map<String,List<JSONObject>> abConfigMap,String code,Integer hourOfDay){
        Boolean flag=false;
        for(JSONObject object:abConfigMap.getOrDefault(code,new ArrayList<>())){
            if(object.getInteger("x")<=hourOfDay&&hourOfDay<object.getInteger("y")){
                return true;
            }
        }
        //
        return flag;
    }

    public Boolean inAdTimeTest(JSONObject abExpInfo){
        //todo youhua
        List<Map<String,Object>> mapList=(List)abExpInfo.get("ab_test002");
        for(Map<String,Object> map:mapList){
            if(adTestCode.equals(map.getOrDefault("abExpCode",""))){
                return true;
            }
        }
        //
        return false;
    }

}
